"""
eBook finder using google search engine (via pygoogle)

SearchBot is the Thread that do the actual ebook searching.

@author:    Charlie Kim <nabugoon@gmail.com>
@license:   BPL
@version:   0.1
"""

from threading import *
import socket
import google
import urllib
import urllister
import re
import wx

ID_START = wx.NewId()
ID_STOP = wx.NewId()

EVT_RESULT_ID = wx.NewId()
EVT_APPEND_ID = wx.NewId()

def EVT_RESULT(win, func):
    win.Connect(-1, -1, EVT_RESULT_ID, func)

def EVT_APPEND(win, func):
    win.Connect(-1, -1, EVT_APPEND_ID, func)
	
class ResultEvent(wx.PyEvent):
    def __init__(self, data):
        wx.PyEvent.__init__(self)
        self.SetEventType(EVT_RESULT_ID)
        self.data = data

class AppendEvent(wx.PyEvent):
    def __init__(self, data):
        wx.PyEvent.__init__(self)
        self.SetEventType(EVT_APPEND_ID)
        self.data = data
	
class SearchBot(Thread):
    def __init__(self, query, pwindow):
    	Thread.__init__(self)
        self.pwindow = pwindow
        self.query = query
        self._want_abort = 0
        self.start()

    def run(self):
    	urlList = []
        query = self.query + " intitle:'index of' 'parent directory'"
        #google.setLicense("")
        data = google.doGoogleSearch(query)

        #for result in data.results:
        #    temp.append((result.URL, result.URL))
        self.updateUrlList(urlList, data)
        wx.PostEvent(self.pwindow, ResultEvent(urlList))

    def updateUrlList(self, urlList, data):
        repeat = 0
        for result in data.results:
            repeat = repeat + 1
            if self._want_abort:
                wx.PostEvent(self.pwindow, ResultEvent(urlList))
                return

            socket.setdefaulttimeout(5)
            try:
                usock = urllib.urlopen(result.URL)
            except IOError, e:
                repeat = repeat - 1
                continue

            parser = urllister.URLLister()
            parser.feed(usock.read())
            usock.close()
            parser.close()

            for url in parser.urls:
                urlList.append((result.URL, url))
                wx.PostEvent(self.pwindow, AppendEvent((result.URL, url)))
                if repeat > 10: #FIXME:Hardcoding
                    wx.PostEvent(self.pwindow, ResultEvent(urlList))
                    return

    def abort(self):
        self._want_abort = 1